#pragma once

#include <gl\gl.h>
#include <gl\glu.h>

class COpenGLRendererBase
{
public:
	COpenGLRendererBase();
	~COpenGLRendererBase();

	// oϐ
private:
	HGLRC	m_hRC;
	HDC		m_hDC;
protected:
	int		m_cx;
	int		m_cy;

	// o֐
private:
	bool	InitializeOpenGL( HWND hWnd );
	bool	SetupPixelFormat();
	bool	SetupViewport();
	bool	PreRenderScene() { return true; }
	void	RenderStockScene();
	bool	RenderScene() { return true; }
	bool	PostRenderScene() { return true; }
	void	RenderAxis();
protected:
	virtual bool	SetupProjectionMatrix();
	virtual bool	SetupModelViewMatrix();
public:
	void	UninitializeOpenGL( HWND hWnd );
	void	ChangeSize( HWND hWnd, int cx, int cy );
	void	Render();
};

